import { Args, Command } from '@oclif/core';
export default class Createuser extends Command {
    static args = {
        Tables: Args.string({ description: 'Enter Table Names', required: true, multiple: true }),
    };
    async run() {
        const { args } = await this.parse(Createuser);
        const { Tables } = args;
        let token = '';
        try {
            const response = await fetch('http://localhost:3333/user', {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                    name: `lfi-admin`,
                    email: `lfiAdmin@gmail.com`,
                    password: `admin`
                }),
            });
            if (!response.ok) {
                throw new Error(`Failed to fetch: ${response.statusText}`);
            }
            const responseData = await response.json();
            if (responseData) {
                const accessToken = await fetch('http://localhost:3333/user/access', {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    body: JSON.stringify({
                        email: `lfiAdmin@gmail.com`,
                        password: `admin`
                    }),
                });
                if (!accessToken.ok) {
                    throw new Error(`Failed to fetch: ${accessToken.statusText}`);
                }
                const accessresponseData = await accessToken.json();
                token = accessresponseData?.token;
                if (accessresponseData) {
                    const roleAdmin = await fetch('http://localhost:3333/role', {
                        method: 'POST',
                        headers: {
                            'Content-Type': 'application/json',
                            Authorization: `Bearer ${token}`,
                        },
                        body: JSON.stringify({
                            roleName: 'ADMIN',
                        }),
                    });
                    if (!roleAdmin.ok) {
                        throw new Error(`Failed to fetch: ${roleAdmin.statusText}`);
                    }
                    const roleAdminResponseData = await roleAdmin.json();
                    if (roleAdminResponseData) {
                        const tables = Tables.split(', ');
                        tables?.map(async (table) => {
                            await fetch('http://localhost:3333/permissions', {
                                method: 'POST',
                                headers: {
                                    'Content-Type': 'application/json',
                                    Authorization: `Bearer ${token}`,
                                },
                                body: JSON.stringify({
                                    tableName: `${table}`,
                                    create: true,
                                    view: true,
                                    update: true,
                                    delete: true,
                                    roleId: roleAdminResponseData?.id,
                                }),
                            });
                        });
                        const updateUser = await fetch(`http://localhost:3333/user/${responseData.id}`, {
                            method: 'PATCH',
                            headers: {
                                'Content-Type': 'application/json',
                                Authorization: `Bearer ${token}`,
                            },
                            body: JSON.stringify({
                                roleId: roleAdminResponseData?.id,
                            }),
                        });
                        if (!updateUser.ok) {
                            throw new Error(`Failed to fetch: ${updateUser.statusText}`);
                        }
                        const updateUserResponseData = await updateUser.json();
                    }
                }
            }
            this.log(`name : lfi-admin, email: lfiAdmin@gmail.com, password: admin`);
        }
        catch (error) {
            this.error('Error:', error);
        }
    }
}
